import requests, json



def updateConfluence(project_name,app_name,version,env):

    try:

        CONFLUENCE_HOST = "tehami.atlassian.net"
        ENV_PAGE_DICT = {
            "DEV": 131211,
            "QA": 196627,
            "PERF": 524289,
            "PROD": 393237
        }

        # Receive from Pub/Sub


        session = requests.Session()
        session.auth = ("mohammadtehami@yahoo.com", "XXXXXXXXXXXXXXXXXXXXX")

        # Get current content
        x = session.get("https://{}/wiki/rest/api/content/{}?expand=body.storage".format(CONFLUENCE_HOST, ENV_PAGE_DICT[env]))
        page = x.json()
        old_content = x.json()["body"]["storage"]["value"]

        # Get current page version
        x = session.get("https://{}/wiki/rest/api/content/{}?expand=version".format(CONFLUENCE_HOST, ENV_PAGE_DICT[env]))
        page_version = x.json()["version"]["number"]

        # Update content
        old_row_without_artifact_version = "<tr><td><p>{}</p></td><td><p>{}</p></td><td><p>".format(project_name, app_name)
        version_index = old_content.index("<tr><td><p>{}</p></td><td><p>{}</p></td><td><p>".format(project_name, app_name)) + len(old_row_without_artifact_version)
        old_artifact_version = ""

        for i in range(1, 20):
          if old_content[version_index + i: version_index + i + 4] == "</p>":
            old_artifact_version = old_content[version_index:version_index + i]
            break

        old_row = "<tr><td><p>{}</p></td><td><p>{}</p></td><td><p>{}</p></td></tr>".format(project_name, app_name, old_artifact_version)

        new_content = old_content.replace(old_row, "<tr><td><p>{}</p></td><td><p>{}</p></td><td><p>{}</p></td></tr>".format(project_name, app_name, version))

        obj = {
          "id": page["id"],
          "type": "page",
          "title": page["title"],
          "body": {
            "storage": {
              "value": new_content,
              "representation": "storage"
            }
          },
          "version": {
            "number": page_version + 1
          }
        }

        headers = {"Content-Type": "application/json"}
        x = session.put("https://{}/wiki/rest/api/content/{}?expand=body.storage".format(CONFLUENCE_HOST, ENV_PAGE_DICT[env]), data=json.dumps(obj), headers=headers)
        print ("Successfully updating the confluence")
    except Exception as e:
        print("Failed updating the confluence")
        print("Error: " + str(e))