import requests
import base64
import json
# from google.cloud import datastore
from google.cloud import firestore
import datetime;

jenkins_uri = '34.81.121.147:8080'
auth=("asad","XXXXXXXXXXXXXXXXXXXXXX")
build_token="token"

def hello_pubsub(event, context):
  pubsub_message = base64.b64decode(event['data']).decode('utf-8')
  print(pubsub_message)
  print(type(pubsub_message))
  execution_details = json.loads(pubsub_message)

  try:
    db = firestore.Client()
    docs = db.collection(u'requestArtifactDeployment').where(u'intendID', u'==', execution_details["intendID"]).stream()
    for doc in docs:
        requestedArtifact=doc.to_dict()
        print(f'{doc.id} => {doc.to_dict()}')
    requestedArtifact["approverEmail"] = execution_details["approverEmail"]
    requestedArtifact["approve"] = execution_details["approve"]
    requestedArtifact["timestamp"] = datetime.datetime.now()
    requestedArtifact["intendID"] = execution_details["intendID"]


    print(requestedArtifact)
  except Exception as e:
    print("Failed reading data from firestore or no recrod found against intentId found")
    print("Error: " + str(e))
  start_build_url = 'http://{}/job/{}/job/{}/buildWithParameters?token={}'.format(jenkins_uri,requestedArtifact["projectName"],requestedArtifact["artifactName"], build_token)
  print(requestedArtifact["artifactVersion"])
  print(start_build_url)
  try:
    if requestedArtifact["approve"]== "Yes":
      response = requests.post(start_build_url, auth=auth, params=requestedArtifact)
      print(response.status_code)
      if (str(response.status_code) == "201"):
        print("Jenkins job is triggered")
        db.collection(u'approveArtifactDeployment').add(requestedArtifact) 
    else:
        db.collection(u'approveArtifactDeployment').add(requestedArtifact)
        print("Approver Decline the request , pipeline is not triggered") 
  except Exception as e:
    print("Failed triggering the Jenkins job")
    print("Error: " + str(e))

  